<?php
	namespace Drupal\idealcheckout\PluginForm;

	use Drupal\Core\Form\FormStateInterface;
	use Drupal\commerce_payment\PluginForm\PaymentOffsiteForm as BasePaymentOffsiteForm;
	use Drupal\commerce_payment\PluginForm\PaymentOffsiteForm;
	use Drupal\idealcheckout\idealcheckout;
	use Drupal\commerce_shipping\Entity;

	class idealcheckout_redirect extends BasePaymentOffsiteForm
	{

	  /**
	   * {@inheritdoc}
	   */
		public function buildConfigurationForm(array $form, FormStateInterface $form_state)
		{
			$form = parent::buildConfigurationForm($form, $form_state);

			/** @var \Drupal\commerce_payment\Entity\PaymentInterface $oPayment */
			$oPayment = $this->entity;

			$sPaymentMethod = $oPayment->getPaymentGatewayId();


			$oOrder = $oPayment->getOrder();

			/** @var \Drupal\commerce_payment\Plugin\Commerce\PaymentGateway\OffsitePaymentGatewayInterface $payment_gateway_plugin */

			$payment_gateway_plugin = $oPayment->getPaymentGateway()->getPlugin();
			$payment_gateway_configuration = $payment_gateway_plugin->getConfiguration();

			$fAmount = $oOrder->getTotalPrice()->getNumber();
			$sPaymentMethod = $payment_gateway_configuration['configuration']['payment_methods'];
			$sOrderId = $oPayment->getOrderId();

			$oEntityManager = \Drupal::entityTypeManager();
			$oOrderValue = $oEntityManager->getStorage('commerce_order')->load($sOrderId);

			$oProfile = $oEntityManager->getStorage('profile')->load($sOrderId);
			
			$oIdealcheckout = new idealcheckout($fAmount, $sPaymentMethod, $sOrderId);

			$sUrl = $form['#return_url'];

			$sReturnUrl = $form['#return_url'];
			$sFailureUrl = $form['#cancel_url'];
			$sOrderCode = $oIdealcheckout->getOrderCode();

			$oIdealcheckout->setUrls($sUrl);

			$oIdealcheckout->setTransactionFailureUrl($sFailureUrl . '?order_id=' . $sOrderId . '&order_code=' . $sOrderCode);

			$aBillingInformation = $oOrderValue->billing_profile->entity->address->getValue();

			// Set Billing And Shipping Data

			// $sEmailAddress = $oOrder->getEmail();
			$sEmailAddress = $oOrderValue->getEmail();
			
			if($oOrder === $oOrderValue)
			{
				print_r('equal');
			}
			else
			{
				print_r('non equal');
			}

			$oIdealcheckout->setEmailAddress($sEmailAddress);

			// Set Billing Data


			$sBillingCountryCode = $aBillingInformation[0]['country_code'];
			$sBillingCity = $aBillingInformation[0]['locality'];
			$sBillingZip = $aBillingInformation[0]['postal_code'];
			$sBillingStreetName = $aBillingInformation[0]['address_line1'];
			$sBillingHouseNumber = $aBillingInformation[0]['address_line2'];
			$sBillingCompany = $aBillingInformation[0]['organization'];
			$sBillingFirstName = $aBillingInformation[0]['given_name'];
			$sBillingNameAddition = $aBillingInformation[0]['additional_name'];
			$sBillingLastName = $aBillingInformation[0]['family_name'];

			$aCombinedLastName = array($sBillingNameAddition, $sBillingLastName);
			$sCombinedLastName = implode(" ", $aCombinedLastName);

			// $oIdealcheckout->setBillingCountryCode($sBillingCountryCode);
			// $oIdealcheckout->setBillingCity($sBillingCity);
			// $oIdealcheckout->setBillingZip($sBillingZip);
			// $oIdealcheckout->setBillingStreetName($sBillingStreetName);
			// $oIdealcheckout->setBillingHouseNumber($sBillingHouseNumber);
			// $oIdealcheckout->setBillingCompany($sBillingCompany);
			// $oIdealcheckout->setBillingFirstName($sBillingFirstName);
			// $oIdealcheckout->setBillingLastName($sCombinedLastName);

			$aOrderParams = array();

			$aOrderParams['payment_company'] = $sBillingCompany;
			$aOrderParams['payment_first_name'] = $sBillingFirstName;
			$aOrderParams['payment_last_name'] = $sCombinedLastName;
			$aOrderParams['payment_gender'] = '';
			$aOrderParams['payment_date_of_birth'] = '';
			$aOrderParams['payment_phone'] = '';
			$aOrderParams['payment_email'] = $sEmailAddress;
			$aOrderParams['payment_street_name'] = $sBillingStreetName;
			$aOrderParams['payment_street_number'] = $sBillingHouseNumber;
			$aOrderParams['payment_zipcode'] = $sBillingZip;
			$aOrderParams['payment_city'] = $sBillingCity;
			$aOrderParams['payment_country_code'] = $sBillingCountryCode;
			$aOrderParams['payment_country_name'] = '';

			$aOrderParams['shipment_company'] = '';
			$aOrderParams['shipment_first_name'] = '';
			$aOrderParams['shipment_last_name'] = '';
			$aOrderParams['shipment_gender'] = '';
			$aOrderParams['shipment_date_of_birth'] = '';
			$aOrderParams['shipment_phone'] = '';
			$aOrderParams['shipment_email'] = $sEmailAddress;
			$aOrderParams['shipment_street_name'] = '';
			$aOrderParams['shipment_street_number'] = '';
			$aOrderParams['shipment_zipcode'] = '';
			$aOrderParams['shipment_city'] = '';
			$aOrderParams['shipment_country_code'] = '';
			$aOrderParams['shipment_country_name'] = '';

			// Set Product Data

			$oCurrentOrder = $oOrder::load($sOrderId);

			$oBillingInformation = $oCurrentOrder->getCustomerId();
			$oCustomer = \Drupal\user\Entity\User::load(\Drupal::currentUser()->id());
			$oCustomerUuid = $oCustomer->uuid();
			// $oShippingInformation  = \Drupal\commerce_shipping\Entity\Shipment::load($oCustomerUuid);
			// $oShippingInformation  = \Drupal\commerce_shipping\Entity\Shipment::load($oCustomerUuid);
			$oShippingInformation = $oEntityManager->loadEntityByUuid('commerce_shipment', $oCustomerUuid);
			$oShipping = $oShippingInformation->getShippingProfile();

			
			// $mMixed = $oBillingInformation::load($sOrderId)


			$aOrderParams['products'] = array();

			foreach($oCurrentOrder->getItems() as $key => $sOrderItem)
			{
				$oProduct = $sOrderItem->getPurchasedEntity();
				$oProductInformation = $oProduct->getProduct();


				print_r($oProductInformation);
				echo "<br>\n" . 'DEBUG: ' . __FILE__ . ' : ' . __LINE__ . "<br>\n";

				$aProduct = array();
				$aProduct['code'] = $oProduct->getProductId();
				$aProduct['description'] = $oProduct->getTitle();
				$aProduct['quantity'] = $oProduct->getQuantity(); // gaat fout
				$aProduct['price_incl'] = round(($oProduct->getPrice()->getNumber())*100);
				$aProduct['price_exl'] = round(($oProduct->getPrice()->getNumber())*100);
				$aProduct['vat'] = 21;

				$aOrderParams['products'][] = $aProduct;
			}



			$oIdealcheckout->setOrderParams($aOrderParams);

			// Send Data to Database

			$oIdealcheckout->createTransactionQuery();
			$oIdealcheckout->executeQuery();

			// Redirect customer

			$sSetupUrl = $oIdealcheckout->getSetupUrl();

			return $this->buildRedirectForm
			(
				$form,
				$form_state,
				$sSetupUrl,
				array(),
				PaymentOffsiteForm::REDIRECT_POST
			);

			exit;
		}
	}
?>