<?php
	namespace Drupal\idealcheckout;

	use Drupal\Core\Render\Element\Checkboxes;
	use Drupal\Core\Url;


	/**
	 * @file
	 * iDEAL Checkout Global Class
	 */

	class idealcheckout
	{
		private $sQuery = '';

		private $sOrderId = '';
		private $sOrderCode = '';
		private $sPaymentMethod = '';
		private $sTransactionId = '';
		private $sTransactionCode = '';
		private $fTransactionAmount = '';
		private $sTransactionDescription = '';

		private $aOrderParams = array();

		private $sTransactionSuccessUrl = '';
		private $sTransactionPaymentUrl = '';
		private $sTransactionPendingUrl = '';
		private $sTransactionFailureUrl = '';

		public function __construct($fAmount, $sPaymentMethod, $sOrderId)
		{
			if(!empty($fAmount) && !empty($sPaymentMethod) && !empty($sOrderId))
			{
				$this->setTransactionAmount($fAmount);
				$this->setPaymentMethod($sPaymentMethod);
				$this->setOrderId($sOrderId);
			}
			else
			{
				die('ERROR');
			}

			$this->setOrderCode(idealcheckout_getRandomCode(32));
			$this->setTransactionCode(idealcheckout_getRandomCode(32));
			$this->setTransactionId(idealcheckout_getRandomCode(32));
			$this->setTransactionDescription(idealcheckout_getRandomCode(32));
		}

		public function setUrls($sUrl)
		{
			 // $this->sTransactionPaymentUrl = idealcheckout_getRootUrl() . 'idealcheckout/setup.php?order_id=' . $this->sOrderId . '&order_code=' . $this->sOrderCode;

			 $this->sTransactionSuccessUrl = $sUrl;
			 $this->sTransactionPaymentUrl = $sUrl;
			 $this->sTransactionPendingUrl = $sUrl;
			 $this->sTransactionFailureUrl = $sUrl;
		}

		public function setTransactionSuccessUrl($sSuccessUrl)
		{
			if(!empty($sSuccessUrl))
			{
				$this->sTransactionSuccessUrl = $sSuccessUrl;

				return true;
			}

			return false;
		}

		public function setTransactionFailureUrl($sFailureUrl)
		{
			if(!empty($sFailureUrl))
			{
				$this->sTransactionFailureUrl = $sFailureUrl;

				return true;
			}

			return false;
		}
		
		public function setTransactionAmount($fTransactionAmount)
		{
			if(!empty($fTransactionAmount))
			{
				$this->fTransactionAmount = $fTransactionAmount;
			}

			return false;
		}

		public function setPaymentMethod($sPaymentMethod)
		{
			if(!empty($sPaymentMethod))
			{
				$this->sPaymentMethod = $sPaymentMethod;
			}

			return false;
		}

		public function setOrderId($sOrderId)
		{
			if(!empty($sOrderId))
			{
				$this->sOrderId = $sOrderId;
			}

			return false;
		}

		public function setOrderCode($sOrderCode)
		{
			if(!empty($sOrderCode))
			{
				$this->sOrderCode = $sOrderCode;

				return true;
			}

			return false;
		}

		public function setTransactionCode($sTransactionCode)
		{
			if(!empty($sTransactionCode))
			{
				$this->sTransactionCode = $sTransactionCode;

				return true;
			}

			return false;
		}

		public function setTransactionId($sTransactionId)
		{
			if(!empty($sTransactionId))
			{
				$this->sTransactionId = $sTransactionId;

				return true;
			}

			return false;
		}

		public function setTransactionDescription($sTransactionDescription)
		{
			if(!empty($sTransactionDescription))
			{
				$this->sTransactionDescription = $sTransactionDescription;

				return true;
			}

			return false;
		}

		public function setOrderParams($aOrderParams)
		{		
			if(!empty($aOrderParams))
			{
				$this->aOrderParams['customer'] = array();
				
				foreach($aOrderParams as $key => $val)
				{
					$this->aOrderParams['customer'][$key] =  $val;
				}
				
				$this->aOrderParams = json_encode($this->aOrderParams);
				
				return true;
			}
			
			return false;
		}

		public function getSetupUrl()
		{
			return idealcheckout_getRootUrl() . 'idealcheckout/setup.php?order_id=' . $this->sOrderId . '&order_code=' . $this->sOrderCode;
		}

		public function getOrderCode()
		{
			return $this->sOrderCode;
		}

		public static function getStatus($sOrderId)
		{
			$aDatabaseSettings = idealcheckout_getDatabaseSettings();

			$sql = "SELECT `transaction_status` FROM `" . $aDatabaseSettings['prefix'] . $aDatabaseSettings['table'] . "` WHERE (`order_id` = '" . $sOrderId . "') LIMIT 1;";

			return idealcheckout_database_getValue($sql);
		}

		public function createTransactionQuery()
		{
			$aDatabaseSettings = idealcheckout_getDatabaseSettings();

			$this->sQuery = "INSERT INTO `" . $aDatabaseSettings['table'] . "` SET
				`order_id` = '" . idealcheckout_escapeSql($this->sOrderId) . "',
				`order_code` = '" . idealcheckout_escapeSql($this->sOrderCode) . "',
				`order_params` = '" . idealcheckout_escapeSql(idealcheckout_serialize($this->aOrderParams)) . "',
				`store_code` = " . (empty($sStoreCode) ? "NULL" : "'" . idealcheckout_escapeSql($sStoreCode) . "'") . ",
				`gateway_code` = '" . idealcheckout_escapeSql($this->sPaymentMethod) . "',
				`language_code` = " . (empty($this->sLanguageCode) ? "NULL" : "'" . idealcheckout_escapeSql($this->sLanguageCode) . "'") . ",
				`country_code` = " . (empty($this->sCountryCode) ? "NULL" : "'" . idealcheckout_escapeSql($this->sCountryCode) . "'") . ",
				`currency_code` = '" . idealcheckout_escapeSql($this->sCurrencyCode) . "',
				`transaction_id` = '" . idealcheckout_escapeSql($this->sTransactionId) . "',
				`transaction_code` = '" . idealcheckout_escapeSql($this->sTransactionCode) . "',
				`transaction_params` = NULL,
				`transaction_date` = '" . idealcheckout_escapeSql(time()) . "',
				`transaction_amount` = '" . idealcheckout_escapeSql($this->fTransactionAmount) . "',
				`transaction_description` = '" . idealcheckout_escapeSql($this->sTransactionDescription) . "',
				`transaction_status` = 'OPEN',
				`transaction_url` = NULL,
				`transaction_payment_url` = '" . idealcheckout_escapeSql($this->sTransactionPaymentUrl) . "',
				`transaction_success_url` = '" . idealcheckout_escapeSql($this->sTransactionSuccessUrl) . "',
				`transaction_pending_url` = '" . idealcheckout_escapeSql($this->sTransactionPendingUrl) . "',
				`transaction_failure_url` = '" . idealcheckout_escapeSql($this->sTransactionFailureUrl) . "',
				`transaction_log` = NULL;";
		}

		public function executeQuery()
		{
			if(!empty($this->sQuery))
			{
				idealcheckout_database_query($this->sQuery);

				return true;
			}

			return false;
		}
	}

?>